#! /usr/bin/env python

import sys
from vvl_lexer import run
import getopt

def usage(show_current = False):
    if show_current:
        print "Current call is:"
        print '%s' % (' '.join(sys.argv),)
    print "Usage: %s [-o output] input" % (sys.argv[0],)

if __name__ == "__main__":
    args = sys.argv[1:]
    inp = None
    output = None
    next_is_output = False
    for a in args:
        if a == '-h':
            usage()
            sys.exit(0)
        elif next_is_output:
            if output:
                usage(True)
                sys.exit(2)
            output = a
            next_is_output = False
        elif a == '-o':
            if next_is_output:
                usage(True)
                sys.exit(2)
            next_is_output = True
        else:
            if inp:
                usage(True)
                sys.exit(2)
            inp = a
    if next_is_output and not output:
        usage(True)
        sys.exit(2)
    if output:
        with open(output, "wt") as out:
            if not run(out, inp):
                sys.exit(1)
    else:
        if not run(sys.stdout, inp):
            sys.exit(1)

