#ifndef VVELIB_SHAPE_POLYHEDRON_H
#define VVELIB_SHAPE_POLYHEDRON_H

#include <config.h>
#include <geometry/geometry.h>

namespace shape
{
  using geometry::Point3d;

  /**
   * Draw a cube
   *
   * \param center Center of the cube
   * \param axis1 Direction of a set of edges
   * \param axis2 The plane formed by (axis1,axis2) contains a set of faces
   * \param size Length of an edge
   */
  void cube(const Point3d& center, const Point3d& axis1, const Point3d& axis2, double size);

  /**
   * Draw a parallelepiped
   *
   * \param corner Position of one of the corner
   * \param edge1 Vector describing a set of edges (length and direction)
   * \param edge2 Vector describing a set of edges (length and direction)
   * \param edge3 Vector describing a set of edges (length and direction)
   */
  void parallelepiped(const Point3d& corner, const Point3d& edge1, const Point3d& edge2, const Point3d& edge3);
}

#endif // VVELIB_SHAPE_POLYHEDRON_H

