#ifndef VVELIB_STORAGE_COMPLEX_H
#define VVELIB_STORAGE_COMPLEX_H

/**
 * \file storage/complex.h
 */

#include <config.h>
#include <storage/storage.h>
#include <storage/graph.h>
#include <algorithms/complex.h>
#include <iostream>

// Included as storing a complex requires storing vectors
#include <storage/vector.h>

namespace vvcomplex
{
  template <typename V1, typename V2, typename E1, typename E2, bool compact>
  bool serialization(storage::VVEStorage& store, VVComplexGraph<V1,V2,E1,E2,compact>& G)
  {
    return serialization(store, (graph::VVBiGraph<V1,V2,E1,E2,compact>&)G);
  }

  template <typename Model, typename CellContent, typename JunctionContent,
           typename WallContent, typename CellEdgeContent, typename CellJunctionContent, typename JunctionCellContent, bool compact,
#ifdef USE_ALLOCATOR
           typename Alloc,
#endif
           typename LeafClass>
  bool VVComplex<ALL_COMPLEX_TEMPLATE_ARGS>::serialize(storage::VVEStorage& store)
  {
    if(!store.field("S", S))
    {
      return false;
    }
    if(!store.field("C", C))
    {
      return false;
    }
    if(!store.field("W", W))
    {
      return false;
    }
    if(save_parameters)
    {
    }
    return true;
  }
}

#endif // VVELIB_STORAGE_COMPLEX_H

