#ifndef VVELIB_STORAGE_UTIL_MATRIX_H
#define VVELIB_STORAGE_UTIL_MATRIX_H

/**
 * \file storage/vector.h
 */

#include <config.h>
#include <storage/storage.h>
#include <util/matrix.h>

namespace util
{
  template <size_t nRows, size_t nCols, typename T>
  bool serialization(storage::VVEStorage& store, Matrix<nRows,nCols,T>& mat)
  {
    for(size_t i = 0 ; i < nRows ; ++i)
    {
      for(size_t j = 0 ; j < nCols ; ++j)
      {
        if(!store.field("V", mat(i,j)))
          return false;
      }
    }
    return true;
  };
}

#endif // VVELIB_STORAGE_UTIL_MATRIX_H

