
#line 1 "/home/ferraro/devlp/vlab/Pascal/vve/vvelib/test/complex.vvh"
#ifndef TEST_COMPLEX_VVH
#define TEST_COMPLEX_VVH

#include <test/test.h>
#include <test/graph.h>

#include <util/forall.h>
#include <util/unorderedset.h>

/**
 * \def CHECK_CONSISTENT_COMPLEX
 *
 * Make sure the various graphs of a cell complex represent the same structure
 */
#define CHECK_CONSISTENT_COMPLEX(T) \
  TEST_RESULT &= test::check_consistentComplex(T, __LINE__)

namespace test
{
  template <typename Complex>
  bool check_consistentComplex(const Complex& T, size_t line_nb)
  {
    bool result = true;
    IMPORT_COMPLEX_TYPES(Complex);
    for(typeof(util::ForAll::range(T.C)) rangeacde9dca_ca3a_11e2_a346_0013722c2d41 = util::ForAll::range(T.C) ; !rangeacde9dca_ca3a_11e2_a346_0013722c2d41.atEnd() ; ++rangeacde9dca_ca3a_11e2_a346_0013722c2d41) {
            const cell& c = *rangeacde9dca_ca3a_11e2_a346_0013722c2d41.current();
#line 26 "/home/ferraro/devlp/vlab/Pascal/vve/vvelib/test/complex.vvh"
{
      for(typeof(util::ForAll::range(T.S.neighbors(c))) rangeacdfbc6e_ca3a_11e2_a346_0013722c2d41 = util::ForAll::range(T.S.neighbors(c)) ; !rangeacdfbc6e_ca3a_11e2_a346_0013722c2d41.atEnd() ; ++rangeacdfbc6e_ca3a_11e2_a346_0013722c2d41) {
            const junction& j = *rangeacdfbc6e_ca3a_11e2_a346_0013722c2d41.current();
#line 28 "/home/ferraro/devlp/vlab/Pascal/vve/vvelib/test/complex.vvh"
{
        const junction& jn = T.S.nextTo(c,j);
        if(!T.W.edge(j,jn))
        {
          if(result) FAILED_FUNCTION(line_nb);
          result = false;
          out << endl << " junction " << toStr(j) << " is after " << toStr(jn) << " in " << toStr(c) << " but the edge is not in W" << endl;
        }
        const cell& oc = T.S.prevTo(j, c);
        if(T.S.prevTo(oc, j) == jn and !T.C.edge(c,oc))
        {
          if(result) FAILED_FUNCTION(line_nb);
          result = false;
          out << endl << " cell " << toStr(c) << " is a neighbor of " << toStr(oc) << " in S but not in C" << endl;
        }
      }}
      for(typeof(util::ForAll::range(T.C.neighbors(c))) rangeace1900c_ca3a_11e2_a346_0013722c2d41 = util::ForAll::range(T.C.neighbors(c)) ; !rangeace1900c_ca3a_11e2_a346_0013722c2d41.atEnd() ; ++rangeace1900c_ca3a_11e2_a346_0013722c2d41) {
            const cell& oc = *rangeace1900c_ca3a_11e2_a346_0013722c2d41.current();
#line 45 "/home/ferraro/devlp/vlab/Pascal/vve/vvelib/test/complex.vvh"
{
        bool foundInS = false;
        for(typeof(util::ForAll::range(T.S.neighbors(c))) rangeace1e00c_ca3a_11e2_a346_0013722c2d41 = util::ForAll::range(T.S.neighbors(c)) ; !rangeace1e00c_ca3a_11e2_a346_0013722c2d41.atEnd() ; ++rangeace1e00c_ca3a_11e2_a346_0013722c2d41) {
            const junction& j = *rangeace1e00c_ca3a_11e2_a346_0013722c2d41.current();
#line 48 "/home/ferraro/devlp/vlab/Pascal/vve/vvelib/test/complex.vvh"
{
          if(T.S.nextTo(j, c) == oc)
          {
            foundInS = true;
            break;
          }
        }}
        if(!foundInS)
        {
          if(result) FAILED_FUNCTION(line_nb);
          result = false;
          out << endl << " cell " << toStr(c) << " is neighbor of " << toStr(oc) << " in C but not in S" << endl;
        }
      }}
    }}
    for(typeof(util::ForAll::range(T.W)) rangeace36508_ca3a_11e2_a346_0013722c2d41 = util::ForAll::range(T.W) ; !rangeace36508_ca3a_11e2_a346_0013722c2d41.atEnd() ; ++rangeace36508_ca3a_11e2_a346_0013722c2d41) {
            const junction& j = *rangeace36508_ca3a_11e2_a346_0013722c2d41.current();
#line 64 "/home/ferraro/devlp/vlab/Pascal/vve/vvelib/test/complex.vvh"
for(typeof(util::ForAll::range(T.W.neighbors(j))) rangeace36e86_ca3a_11e2_a346_0013722c2d41 = util::ForAll::range(T.W.neighbors(j)) ; !rangeace36e86_ca3a_11e2_a346_0013722c2d41.atEnd() ; ++rangeace36e86_ca3a_11e2_a346_0013722c2d41) {
            const junction& jn = *rangeace36e86_ca3a_11e2_a346_0013722c2d41.current();
#line 65 "/home/ferraro/devlp/vlab/Pascal/vve/vvelib/test/complex.vvh"
{
        bool foundInS = false;
        for(typeof(util::ForAll::range(T.S.neighbors(j))) rangeace37728_ca3a_11e2_a346_0013722c2d41 = util::ForAll::range(T.S.neighbors(j)) ; !rangeace37728_ca3a_11e2_a346_0013722c2d41.atEnd() ; ++rangeace37728_ca3a_11e2_a346_0013722c2d41) {
            const cell& c = *rangeace37728_ca3a_11e2_a346_0013722c2d41.current();
#line 68 "/home/ferraro/devlp/vlab/Pascal/vve/vvelib/test/complex.vvh"
{
          if(T.S.nextTo(c,j) == jn or T.S.prevTo(c,j) == jn)
          {
            foundInS = true;
            break;
          }
        }}
        if(!foundInS)
        {
          if(result) FAILED_FUNCTION(line_nb);
          result = false;
          out << endl << " junction " << toStr(j) << " is neighbor of " << toStr(jn) << " in W but not in S" << endl;
        }
      }}}
    return result;
  }
}

#endif // COMPLEX_VVH

