#ifndef UTIL_LEAF_CLASS_H
#define UTIL_LEAF_CLASS_H

#include <config.h>
/**
 * \file leaf_class.h
 * Define templates and macros to figure out, at compile time, what class is 
 * the leaf class of a chain of inheritance.
 */

/**
 * \namespace template_utils
 * Namespace for meta-programming utils using templates
 */
namespace template_utils
{
  class this_class {};

  template <class T, class Self>
  struct resolve_this
  {
    typedef T type;
  };

  template<class Self>
  struct resolve_this<this_class,Self>
  {
    typedef Self type;
  };

#define RESOLVE_LEAF_CLASS(T,Self) typename template_utils::resolve_this<T,Self>::type
};

#endif // UTIL_LEAF_CLASS_H

