#ifndef VVELIB_UTIL_UNORDEREDMAP_H
#define VVELIB_UTIL_UNORDEREDMAP_H

#include <config.h>

#ifdef USE_HASH
#  ifdef __GNUC__
#    include <util/features.h>
#    ifdef __GXX_EXPERIMENTAL_CXX0X__
#      include <unordered_map>
#    elif __GNUC_PREREQ(4,0)
#      include <tr1/unordered_map>
#      ifndef CXX_NEEDS_TR1
#        define CXX_NEEDS_TR1
#      endif
namespace std
{
  using std::tr1::unordered_map;
  using std::tr1::unordered_multimap;
  using std::tr1::hash;
}
#    else
#      error "GCC do not have unordered_set before the version 4.0"
#    endif
#  elif defined(_MSC_VER)
#    include <unordered_map>
#    ifndef CXX_NEEDS_TR1
#      define CXX_NEEDS_TR1
#    endif
namespace std
{
  using std::tr1::unordered_map;
  using std::tr1::unordered_multimap;
  using std::tr1::hash;
}
#  else
#    error "unordered_map is not identified for your compiler"
#  endif
#else
#  include <map>
#  define unordered_map map
#  define unordered_multimap multimap
#endif

#endif // VVELIB_UTIL_UNORDEREDMAP_H

