#ifndef VVLIB_UTIL_UNORDEREDSET_H
#define VVLIB_UTIL_UNORDEREDSET_H

#include <config.h>

#ifdef USE_HASH
#  ifdef __GNUC__
#    include <util/features.h>
#    ifdef __GXX_EXPERIMENTAL_CXX0X__
#      include <unordered_set>
#    elif __GNUC_PREREQ(4,0)
#      include <tr1/unordered_set>
#      ifndef CXX_NEEDS_TR1
#        define CXX_NEEDS_TR1
#      endif
namespace std
{
  using std::tr1::unordered_set;
  using std::tr1::unordered_multiset;
  using std::tr1::hash;
}
#    else
#      error "GCC do not have unordered_set before the version 4.0"
#    endif
#  elif defined(_MSC_VER)
#    include <unordered_set>
#    ifndef CXX_NEEDS_TR1
#      define CXX_NEEDS_TR1
#    endif
namespace std
{
  using std::tr1::unordered_set;
  using std::tr1::unordered_multiset;
  using std::tr1::hash;
}
#  else
#    error "unordered_set is not identified for your compiler"
#  endif
#else
#  include <set>
#  define unordered_set set
#  define unordered_multiset multiset
#endif

#endif // VVLIB_UTIL_UNORDEREDSET_H

