#ifndef VVALL_H
#define VVALL_H

#include <config.h>
#include <model.h>
#include <viewer.h>
// No need to include these twice ...
//#include <graph/vertex.h>
//#include <graph/edge.h>
//#include <graph/vvgraph.h>
//#include <graph/vvbigraph.h>
#include <util/forall.h>
#include <algorithms/tissue.h>
#include <geometry/geometry.h>

#ifdef __GNUC__
# define DLLEXPORT
#else
# define DLLEXPORT __declspec( dllexport )
#endif

#define DEFINE_MODEL( classname ) \
  extern "C" { \
    DLLEXPORT Model* create_model( QObject* parent ) \
      { \
      return new classname(parent); \
      } \
  }

#define DEFINE_VIEWER( classname ) \
  extern "C" { \
    DLLEXPORT Viewer* create_viewer( QWidget* parent, const QGLWidget* shareWidget, int idx = -1 ) \
      { \
      return new classname(parent, shareWidget, idx); \
      } \
  }


using qglviewer::Vec;
using qglviewer::Camera;
using namespace graph;

using geometry::Point2d;
using geometry::Point3d;
using geometry::Point4d;
using geometry::Matrix2d;
using geometry::Matrix3d;
using geometry::Matrix4d;

#endif // VVALL_H

