[Main]
Rows: 50
Cols: 50
DrawInterval: .05
PrintInterval: 10
RandSeed: 7

[View]
SizeSquare: 1 1
ColorBegin: 0
ColorEnd: 1
ColorContour: 2
ViewConnection: false
ViewContour: false
AVMax: 8

[Chemicals]
AAProd: 10
ADProd: .01
ADecay: .1
ADiff: .02
ANoise: .00001

HAProd: 50
HDProd: 0
HDecay: .5
HDiff: 4//100

[Solver]
Solver: AdaptiveCrankNicholson		// Euler, AdaptiveEuler, Fixedpoint, 
                                        // Midpoint, RungeKutta, 
                                        // AdaptiveRungeKutta, 
                                        // AdaptiveCrankNicholson

// Global help:
//  *TolType can be MeanComponent or MaxComponent

// Various Timesteps
EulerDt: .05//.0025			// Timestep for Euler solver
FixedPointDt: .06			// Timestep for fixed point solver
MidPointDt: .06				// Timestep for midpoint solver
RungeKuttaDt: .08			// Timestep for Runge-Kutta 4th order
InitialDt: 1				// Beginning timestep for adaptive solvers
MaxDt: 25				// Maximum Dt

// Adaptive Euler parms
AEulerIncDt: .1				// Adaptive Euler Dt increment/decrement
AEulerResDt: .5				// Adaptive Euler restart Dt decrement
AEulerMinDt: .001			// Adaptive Euler min Dt
AEulerMaxDt: .25			// Adaptive Euler max Dt
AEulerTolType: MaxComponent		// Tolerence type for adaptive Euler
AEulerResTol: 1				// Adaptive Euler restart tolerance
AEulerLowTol: .3			// Adaptive Euler low water mark
AEulerHighTol: .4			// Adaptive Euler high water mark

// Fixed Point iteration parms
FixedPointMaxSteps: 5		// Max steps for fixed point iteration
FixedPointTol: .0001			// Tolerance for fixed point iteration
FixedPointTolType: MaxComponent

// Adaptive Runge-Kutta parms
ARungeIncDt: .01			// Adaptive Runge-Kutta Dt increment/decrement
ARungeResDt: .5				// Adaptive Runge-Kutta restart Dt decrement
ARungeMinDt: .001			// Adaptive Runge-Kutta min Dt
ARungeMaxDt: 1				// Adaptive Runge-Kutta max Dt
ARungeTolType: MaxComponent		// Tolerence type for adaptive Runge-Kutta 
ARungeResTol: 1				// Adaptive Runge-Kutta restart tolerance
ARungeLowTol: .03			// Adaptive Runge-Kutta low water mark
ARungeHighTol: .05			// Adaptive Runge-Kutta high water mark

// Crank Nicholson params
CRIncDt: .2				// Increment for timestep based on efficiency (mulitple of current size)
CRResDt: .5				// Decrement for timestep if unsucc
CRAvgCPU: .5                            // Weight of current dt in eff average
CRMinCPU: 5				// Minimun CPU, below this alway increases timestep

// Newton Tolerance (used by Crank Nicholson)
NewtTol: .01				// Tolerence for Newton's method
NewtTolType: MeanComponent
NewtMaxSteps: 10 			// Max steps for Newton's method

// Conjugate gradient params (used by Crank Nicholson)
ConjGradTol: .001			// Tolerence for conjugate gradient
ConjGradTolType: MeanComponent
ConjGradMaxSteps: .05			// Max steps for conjugate gradient (multiple of N)
ConstNbPartials: true			// Set if partials to neighbors are constant (diffusion only)

// Misc general parms
Dx: .0001				// Delta for numerical diff
PrintMatrix: false			// Print Matrix (Conj-Grad)
PrintStats: 0

