[Main]			// Main model parameters
KeyFrameFile: grow_at_top.anim
GrowthStartTime: 0.0
CellInitWalls: 200
DrawInterval: 1
PrintInterval: 50
GrowthInterval: 0.5
GrowthTimeRatio: 500

[View]			// Viewing parameters
BackColor: 1.0
CellColorBegin: 18
CellColorEnd: 19
CellColorCenter: .2
CellContourColor: 20
DrawInsideCells: true
DrawCellBorders: true
CellWallCorner: .15
CellWallWidth: .025
ShowNeighbors: false
CellBlending: 1.0
CellCenterBlending: 1.0

[Tissue]			// Tissue model parameters
DivisionAlgorithm: ShortWall // ClosestWall ShortWall ClosestMid
CellPinch: .7
CellMaxPinch: .1
CellMaxArea: 0.5
CellWallMin: 0.03
CellWallSample: 0.05
OrderCellDivision: true
CellSampleDx: 0.001

[Chems]			// Chemical paramters
DivisionNoise: 0.01		// Asymetry introduced in cell division

[Activator]
Diffusion: 0.0		// activator diffusion constant
Production: 1.0		// activator production
Decay: 2		// activator decay
Saturation: 0.0		// activator saturation
Autocatalysis: 15.00	// activator auto-catalysis constant
MaxView: 8.0

[Inhibitor]
Diffusion: 7		// inhibitor diffusion constant
Production: 2.0		// inhibitor production
Decay: 5		// inhibitor decay
Inhibition: 2.0		// inhibitor multiplicative constant
MaxView: 30.0

[Solver]
Solver: AdaptiveCrankNicholson		// Euler, AdaptiveEuler, Fixedpoint, 
                                        // Midpoint, RungeKutta, 
                                        // AdaptiveRungeKutta, 
                                        // AdaptiveCrankNicholson

// Global help:
//  *TolType can be MeanComponent or MaxComponent

// Various Timesteps
EulerDt: .001 //.0025			// Timestep for Euler solver
FixedPointDt: .06			// Timestep for fixed point solver
MidPointDt: .06				// Timestep for midpoint solver
RungeKuttaDt: .01			// Timestep for Runge-Kutta 4th order
InitialDt: 1				// Beginning timestep for adaptive solvers
MaxDt: 25				// Maximum Dt

// Adaptive Euler parms
AEulerIncDt: .1				// Adaptive Euler Dt increment/decrement
AEulerResDt: .5				// Adaptive Euler restart Dt decrement
AEulerMinDt: .001			// Adaptive Euler min Dt
AEulerMaxDt: .25			// Adaptive Euler max Dt
AEulerTolType: MaxComponent		// Tolerence type for adaptive Euler
AEulerResTol: 1				// Adaptive Euler restart tolerance
AEulerLowTol: .3			// Adaptive Euler low water mark
AEulerHighTol: .4			// Adaptive Euler high water mark

// Fixed Point iteration parms
FixedPointMaxSteps: 5		// Max steps for fixed point iteration
FixedPointTol: .0001			// Tolerance for fixed point iteration
FixedPointTolType: MaxComponent

// Adaptive Runge-Kutta parms
ARungeIncDt: .01			// Adaptive Runge-Kutta Dt increment/decrement
ARungeResDt: .5				// Adaptive Runge-Kutta restart Dt decrement
ARungeMinDt: .001			// Adaptive Runge-Kutta min Dt
ARungeMaxDt: 1				// Adaptive Runge-Kutta max Dt
ARungeTolType: MaxComponent		// Tolerence type for adaptive Runge-Kutta 
ARungeResTol: 1				// Adaptive Runge-Kutta restart tolerance
ARungeLowTol: .03			// Adaptive Runge-Kutta low water mark
ARungeHighTol: .05			// Adaptive Runge-Kutta high water mark

// Crank Nicholson params
CRIncDt: .2				// Increment for timestep based on efficiency (mulitple of current size)
CRResDt: .5				// Decrement for timestep if unsucc
CRAvgCPU: .5                            // Weight of current dt in eff average
CRMinCPU: 5				// Minimun CPU, below this alway increases timestep

// Newton Tolerance (used by Crank Nicholson)
NewtTol: .001				// Tolerence for Newton's method
NewtTolType: MeanComponent
NewtMaxSteps: 10 			// Max steps for Newton's method

// Conjugate gradient params (used by Crank Nicholson)
ConjGradTol: .001			// Tolerence for conjugate gradient
ConjGradTolType: MeanComponent
ConjGradMaxSteps: .05			// Max steps for conjugate gradient (multiple of N)
ConstNbPartials: true			// Set if partials to neighbors are constant (diffusion only)

// Misc general parms
Dx: .0001				// Delta for numerical diff
PrintMatrix: false			// Print Matrix (Conj-Grad)
PrintStats: 0

