#include <util/vector.h>

#include "model.cpp"

class PalamadustaDiliculumModel : public NautilusPompiliusModel
{
public:
  double sinWidth;

  PalamadustaDiliculumModel(QObject *parent)
    : NautilusPompiliusModel(parent, false)
  {
    init();
  }

  void readRDParams( util::Parms& parms )
  {
    NautilusPompiliusModel::readRDParams(parms);

    parms("Chemicals", "SinWidth", sinWidth);
  }

  void initCell(vertex v)
  {
    double x = double(v->pos)*cellWidth;
    v->sigma = (1+sin((x*2*M_PI)/sinWidth))*(sigmamax - sigmamin) + sigmamin;
  }

};

DEFINE_MODEL(PalamadustaDiliculumModel);

