#include <util/vector.h>

#include "model.cpp"

class PalmadustaZiezaeModel : public NautilusPompiliusModel
{
public:
  double sinWidth;
  Point2d sinPoints;

  PalmadustaZiezaeModel(QObject *parent)
    : NautilusPompiliusModel(parent, false)
  {
    init();
  }

  void readRDParams( util::Parms& parms )
  {
    NautilusPompiliusModel::readRDParams(parms);

    parms("Chemicals", "SinWidth", sinWidth);
    parms("Chemicals", "SinPoints", sinPoints);
  }

  void initCell(vertex v)
  {
    double x = v->pos*cellWidth / sinWidth;
    double t = fmod(x,1)*sinPoints[1];
    if(t < sinPoints[0])
    {
      double t1 = t*M_PI_2/sinPoints[0];
      v->sigma = (1+sin(t1))/2 * (sigmamax-sigmamin) + sigmamin;
    }
    else
    {
      v->sigma = sigmamin;
    }
  }

};

DEFINE_MODEL(PalmadustaZiezaeModel);

