BASE_DIR=$$system(dirname `which vveinterpreter`)

vvl.name = Generates C++ files from VVL files
vvl.output = ${QMAKE_FILE_BASE}.cpp
vvl.commands = python $$BASE_DIR/vvl2cpp.py -o ${QMAKE_FILE_OUT} ${QMAKE_FILE_IN}
vvl.input = VVL_FILES
vvl.dependency_type = TYPE_C
vvl.variable_out = SOURCES

vvh.name = Generates C++ header files from VVH files
vvh.output = ${QMAKE_FILE_BASE}.h
vvh.commands = python $$BASE_DIR/vvl2cpp.py -o ${QMAKE_FILE_OUT} ${QMAKE_FILE_IN}
vvh.input = VVH_FILES
vvh.dependency_type = TYPE_C
vvh.variable_out = HEADERS

QMAKE_MAC_SDK= 
CONFIG+=

QMAKE_EXTRA_COMPILERS += vvl vvh

INCLUDEPATH=  -I$(VVEDIR)/include/vvelib -I$(VVEDIR)/include -I $(QTDIR)/include -I $(QTDIR)/include/QtCore -I $(QTDIR)/include/QtXml -I $(QTDIR)/include/QtOpenGL -I $(QTDIR)/include/QtGui

LIBS += -L$(VVEDIR)/lib -L$(QTDIR)/lib

CONFIG += qt shared

QT += opengl xml

QMAKE_CXXFLAGS_RELEASE= -DQT_DLL -DQT_OPENGL_LIB -DQT_DESIGNER_LIB -DQT_UITOOLS_LIB -DQT_GUI_LIB -DQT_XML_LIB -DQT_CORE_LIB -DQT_DLL  -O3 -pipe -m32 -mfpmath=sse -msse3 -W -Wall -Wno-system-headers
QMAKE_CXXFLAGS_DEBUG= -DQT_DLL -DQT_OPENGL_LIB -DQT_DESIGNER_LIB -DQT_UITOOLS_LIB -DQT_GUI_LIB -DQT_XML_LIB -DQT_CORE_LIB -DQT_DLL  -g -pipe -m32

macx: {
LIBS += -framework Carbon
}


contains(TEMPLATE,lib) {
LIBS += -lvvelib_shape -lvvelib_algorithms -lvvelib_factory -lvvelib_storage -lvvelib_geometry -lvvelib_util -lvvelib_graph -lvvelib_test  -lvvelib -lGLU
REAL_TARGET="$$TARGET".vve

QMAKE_POST_LINK = $(COPY_FILE) $(TARGET) $$REAL_TARGET

QMAKE_CLEAN += $(REAL_TARGET)

QMAKE_LFLAGS=-pipe -m64 -mfpmath=sse -msse3 -rdynamic -Wl,--version-script=model.expmap
}
else {
LIBS += -lvveinterpreter_lib -lvvelib_static  -lvvelib_shape_static -lvvelib_algorithms_static -lvvelib_factory_static -lvvelib_storage_static -lvvelib_geometry_static -lvvelib_util_static -lvvelib_graph_static -lvvelib_test_static
QMAKE_LFLAGS=-pipe -m64 -mfpmath=sse -msse3 -Wl,--version-script=model.expmap -rdynamic
}

